config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  get "/data_files/new",to: "data_files#new", as: "data_files_new"
  root "data_files#new"
  get "/data_files/show",to: "data_files#show", as: "data_files_show"
  post "/data_files/upload",to: "data_files#upload", as: "data_files_upload"

end

app/models/affiliation.rb
class Affiliation < ApplicationRecord
  #----modules------
  include ModelAttrsModule

  #----relations------
  has_and_belongs_to_many :people, -> { distinct } do
    def << (value)
      super value rescue ActiveRecord::RecordNotUnique
    end
  end

  #----validations------
  validates :name, presence: true, uniqueness: true
  validates_with AttributeTitlecaseValidator, {attr_name:"name"}
  before_validation {attr_string_to_title_case("name")}
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/data_file.rb
class DataFile#PORO
  # ------modules-----
  include ActiveModel::Validations
  include DataFilesModule

  # ------validations------
  validates :data_file, presence: true
  #test=>Class=> Rack::Test::UploadedFile
  #{\"file\"=>#<Rack::Test::UploadedFile:0x00007ffa67bacd68 @original_filename=\"data.csv\", @tempfile=#<Tempfile:/var/../dl0d4.csv>, @content_type=nil>}
  #browser GUI=> Class =>ActionDispatch::Http::UploadedFile
  # "file"=>
  #   #<ActionDispatch::Http::UploadedFile:0x00007fe0ea31b618
  #    @content_type="text/csv",
  #    @headers="Content-Disposition: form-data; name=\"file\"; filename=\"data.csv\"\r\n" + "Content-Type: text/csv\r\n",
  #    @original_filename="data.csv",
  #    @tempfile=#<File:/var/../srmt4c.csv>>,
  validates_with AttributeFileValidator, {attr_name:"data_file"}
end

app/models/location.rb
class Location < ApplicationRecord
  #----modules------
  include ModelAttrsModule

  #----relations------
  has_and_belongs_to_many :people, -> { distinct } do
    def << (value)
      super value rescue ActiveRecord::RecordNotUnique
    end
  end

  #----validations------
  validates :name, presence: true, uniqueness: true
  validates_with AttributeTitlecaseValidator, {attr_name:"name"}
  before_validation {attr_string_to_title_case("name")}
end

app/models/person.rb
class Person < ApplicationRecord
  #----modules------
  include ModelAttrsModule

  #----attrs------
  enum gender: [:male, :female, :other]
  enum species: [:human, :wookie, :hutt,:gungan,:astromech_droid,:protocol_droid,:unknown]

  #----relations------
  # By default HABTM relations don't validate duplicates
  # in the join tables (affiliations_people/locations_people).
  # Doesn't work adding index in the migration file. i.e:
  # add_index :affiliations_people, [:affiliation_id, :person_id], unique: true
  # Following lines work at Object level, i.e:
  # i.e-1 Will not insert @aff1
  # person.affiliations = [@aff1,@aff2]
  # person.affiliations.append(@aff1)
  # i.e-2 Will insert @aff
  # person.affiliations = [@aff1(name="Sith"),@aff2]
  # @aff = find_by(name:"Sith")
  # person.affiliations.append(@aff) #will insert @aff
  has_and_belongs_to_many :affiliations, -> { distinct } do
    def << (value)
      super value rescue ActiveRecord::RecordNotUnique
    end
  end
  has_and_belongs_to_many :locations, -> { distinct } do
    def << (value)
      super value rescue ActiveRecord::RecordNotUnique
    end
  end

  #----validations------
  validates :first_name, presence: true,  uniqueness: { scope: :last_name }
  validates_with AttributeTitlecaseValidator, {attr_name:"first_name"}
  validates_with AttributeTitlecaseValidator, {attr_name:"last_name"}
  before_validation {attr_string_to_title_case("first_name")}
  before_validation {attr_string_to_title_case("last_name")}
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/data_files_controller.rb
class DataFilesController < ApplicationController
  #get new
  def new

  end

  #get show
  def show
    @people=Person.all
  end

  #post upload
  def upload
    csv_file = params[:file]
    data_file_obj = DataFile.new(csv_file)
    if !data_file_obj.valid?
      flash.now[:error] = data_file_obj.errors.full_messages
    else
      if data_file_obj.persist_data
        flash.now[:alert] = I18n.t('messages.notices.valid_file')
        flash.now[:notice] = I18n.t('messages.notices.data_saved')
      else
        flash.now[:alert] = I18n.t('messages.notices.valid_file')
        flash.now[:error] = I18n.t('messages.errors.saving_data')
      end
    end
    render :new
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/person_helper.rb
module PersonHelper

  # @param [Person] person
  # @return [String]. First name + last name if exists
  def format_name(person)
    last_name = person.last_name.is_a?(NilClass)? "" : person.last_name
    return person.first_name+" "+last_name
  end

  # @param [Person] person
  # @return [String]. All person locations. String comma separated
  def format_locations(person)
    all_locations = ""
    person.locations.each { |loc| all_locations+=", "+loc.name }
    all_locations[0]="" #remove the first ,
    all_locations[0]="" #remove the first space ' '
    return all_locations
  end

  # @param [Person] person
  # @return [String]. All person affiliations. String comma separated
  def format_affiliations(person)
    all_affiliations = ""
    person.affiliations.each { |aff| all_affiliations+=", "+aff.name }
    all_affiliations[0]="" #remove the first ,
    all_affiliations[0]="" #remove the first space ' '
    return all_affiliations
  end


end

app/views/data_files/new.html.erb
<h1>FILE DATA TO TABLE</h1>
<h2>Upload CSV File</h2>
<br>
<%= form_tag data_files_upload_path , multipart: true do %>
  <div class="field">
    <%= file_field_tag :file %>
  </div>
  <div class="actions btn btn-primary">
    <%= submit_tag 'Submit'%>
  </div>
<% end %>
<br>
<%= link_to "Show Data", data_files_show_path %>
<br>
<br>
| <%= link_to "Problem Description", "https://gitlab.com/dante.salcedo/file_data_to_table/-/blob/main/problem_description.md" %> | <%= link_to "CSV Files", "https://gitlab.com/dante.salcedo/file_data_to_table/-/tree/main/data_files" %> | <%= link_to "Code", "https://gitlab.com/dante.salcedo/file_data_to_table" %> |

app/views/data_files/show.html.erb
<%= stylesheet_pack_tag 'show' %>
<%= javascript_pack_tag 'show', media: 'all', 'data-turbolinks-track': 'reload' %>

<h1>Show Data</h1>

<table id="dttb" class="table table-hover">
  <thead>
  <tr>
    <th>Name</th>
    <th>Location</th>
    <th>Species</th>
    <th>Gender</th>
    <th>Affiliations</th>
    <th>Weapon</th>
    <th>Vehicle</th>
  </tr>
  </thead>
  <tbody>
  <% @people.each do |person| %>
    <tr>
      <td><%= format_name(person) %></td>
      <td><%= format_locations(person) %></td>
      <td><%= person.species %></td>
      <td><%= person.gender %></td>
      <td><%= format_affiliations(person) %></td>
      <td><%= person.weapon %></td>
      <td><%= person.vehicle %></td>
    </tr>
  <% end %>
  </tbody>
</table>
<br>
<%= link_to "Home", root_path%>

<% content_for :scripts do %>
  <script>
      document.addEventListener('turbolinks:load', function() {
          $('#dttb').DataTable();
      });
  </script>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>FileDataToTable</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <% flash.each do |type, msg| %>
      <div>
        <b>-<%= msg %></b>
      </div>
    <% end %>
    <%= yield %>
  </body>
</html>
<%= yield :scripts %>